NIBCOUNT	= $09

TEMP0   = $10
TEMP1   = $11
TEMP2   = $12
TEMP3   = $13
TEMP4   = $14
TEMP5   = $15

HGR_BITS	= $1C

GBASL		= $26
GBASH		= $27
BASL		= $28
BASH		= $29
MASK		= $2E
MASK_COUNTDOWN	= $2F
PEASANT_PRIORITY	= $30



INVENTORY_MASK	= $60
INVENTORY_Y	= $61

CURSOR_X	= $63
CURSOR_Y	= $64
FRAME		= $65
ALTFIRE		= $66
ALTL		= $67
ALTH		= $68
SAVED_X		= $69
PEASANT_XADD	= $6A
PEASANT_YADD	= $6B
GAME_OVER	= $6C
	NEW_LOCATION	= $FF
	NEW_FROM_DISK	= $01


; pt3 player registers
AY_REGISTERS    = $70
A_FINE_TONE     = $70
A_COARSE_TONE   = $71
B_FINE_TONE     = $72
B_COARSE_TONE   = $73
C_FINE_TONE     = $74
C_COARSE_TONE   = $75
NOISE           = $76
ENABLE          = $77
PT3_MIXER_VAL   = $77
A_VOLUME        = $78
B_VOLUME        = $79
C_VOLUME        = $7A
ENVELOPE_FINE   = $7B
ENVELOPE_COARSE = $7C
ENVELOPE_SHAPE  = $7D
PATTERN_L       = $7E
PATTERN_H       = $7F

WHICH_LOAD	= $80

; rest of pt3_player
PT3_TEMP        = $81
ORNAMENT_L      = $82
ORNAMENT_H      = $83
SAMPLE_L        = $84
SAMPLE_H        = $85
LOOP            = $86
MB_VALUE        = $87
MB_ADDR_L       = $88
MB_ADDR_H       = $89
DONE_PLAYING    = $8A
DONE_SONG       = $8B
APPLEII_MODEL	= $8C
ESC_PRESSED	= $8D

;=======================
; savegame state
;=======================
PEASANT_X	= $90
PEASANT_Y	= $91
PEASANT_DIR	= $92
	PEASANT_DIR_UP		= 0
	PEASANT_DIR_RIGHT	= 1
	PEASANT_DIR_LEFT	= 2
	PEASANT_DIR_DOWN	= 3
MAP_X		= $93
MAP_Y		= $94
MAP_LOCATION	= $95

GAME_STATE_0	= $96
	BABY_IN_WELL=$00
	TURN_WELL_CRANK=$00
	TALK_TO_MENDELEV=$00
	HALDO_TO_DONGELEV=$00
	ARROW_BEATEN=$00
	GARY_SCARED=$00
	LADY_GONE=$00
	TRINKET_GIVEN=$00
	FISH_FED=$00		; also implies man gone and inn open
	PUDDLE_WET=$00
	HAY_BALE=$00
	JHONKA_OUT=$00
	RAINING=$00
	NIGHT=$00
	POT_ON_HEAD=$00
	WEARING_ROBE=$00
	ON_FIRE	= $00
	COTTAGE_ROCK_MOVED=$00
	KNUCKLES_BLEED=$00
	DRESSER_OPEN=$00


NED_STATUS	= $99
BUSH_STATUS	= $9A	; status of bush search
	
KERREK_STATE	= $9B
	KERREK_ALIVE	= $00
	KERREK_DEAD	= $01
	KERREK_DECOMPOSING = $02
	KERREK_SKELETON	= $03
ARROW_SCORE	= $9C	; bottom=score, top=random num needed 3-5?

SCORE_HUNDREDS	= $9D
SCORE_TENSONES	= $9E	


INVENTORY_1	= $A0
	INV1_ARROW		= $01
	INV1_BABY		= $02
	INV1_KERREK_BELT	= $04
	INV1_CHICKEN_FEED	= $08
	INV1_BOW		= $10
	INV1_MONSTER_MASK	= $20
	INV1_PEBBLES		= $40
	INV1_PILLS		= $80

INVENTORY_2	= $A1
	INV2_RICHES		= $01
	INV2_ROBE		= $02
	INV2_SODA		= $04
	INV2_MEATBALL		= $06
	INV2_TRINKET		= $10
	INV2_TROGHELM		= $20
	INV2_TROGSHIELD		= $40
	INV2_TROGSWORD		= $80

INVENTORY_3	= $A2
	INV3_IMPOSSIBLE		= $01
	INV3_SHIRT		= $02
	INV3_MAP		= $04

INVENTORY_1_GONE	= $A3	; had item, but now it's gone
INVENTORY_2_GONE	= $A4
INVENTORY_3_GONE	= $A5


INPUT_X		= $C0
BOX_X1L		= $C1
BOX_X1H		= $C2
BOX_Y1		= $C3
BOX_X2L		= $C4
BOX_X2H		= $C5
BOX_Y2		= $C6
SAVED_Y1	= $C7
SAVED_Y2	= $C8

; D0-D? used by HGR?

WHICH_SLOT	= $DA
CURRENT_DISK	= $DC
HGR_COLOR	= $E4
HGR_PAGE	= $E6

P0		= $F1
P1		= $F2
P2		= $F3
P3		= $F4
P4		= $F5
P5		= $F6


INL		= $FC
INH		= $FD
OUTL		= $FE
OUTH		= $FF

; constants

LOAD_VID_LOGO   = 0
LOAD_TITLE      = 1
LOAD_INTRO      = 2
LOAD_COPY_CHECK = 3
LOAD_PEASANT1   = 4
LOAD_PEASANT2   = 5
LOAD_PEASANT3   = 6
LOAD_PEASANT4   = 7

VGI_RCOLOR      = P0
VGI_RX1         = P1
VGI_RY1         = P2
VGI_RXRUN       = P3
VGI_RYRUN       = P4
VGI_RCOLOR2     = P5    ; only for dither
COUNT		= TEMP5

